﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// Needed for AsStream extension method on IBuffer:
using System.Runtime.InteropServices.WindowsRuntime;

namespace WriteableBitmap
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            // Create a blank bitmap
            Windows.UI.Xaml.Media.Imaging.WriteableBitmap bitmap = 
                new Windows.UI.Xaml.Media.Imaging.WriteableBitmap(1024, 768);

            // Get a .NET Stream for the bitmap's bytes
            using (Stream stream = bitmap.PixelBuffer.AsStream())
            {
                // Write each pixel (4-byte BGRA format, alpha channel ignored) 
                int numPixels = bitmap.PixelWidth * bitmap.PixelHeight;
                for (int i = 0; i < numPixels; i++)
                {
                    stream.WriteByte((byte)(i % 255));         // B
                    stream.WriteByte(0);                       // G
                    stream.WriteByte((byte)(255 - (i % 255))); // R
                    stream.WriteByte(0);                       // A (ignored)
                }
            }

            // Use this as the ImageSource for an Image element
            image.Source = bitmap;
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }
    }
}
