﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;

namespace Chapter17
{
    public class RawCountToDescriptionConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter,
                              string language)
        {
            // Let Parse throw an exception if the input is bad
            int num = int.Parse(value.ToString());
            if (num == 0)
            {
                return "There are no photos yet. Add some!";
            }
            else
            {
                return num.ToString("N0") + (num == 1 ? " photo" : " photos");
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter,
                                  string language)
        {
            return DependencyProperty.UnsetValue;
        }
    }
}